<template>
    <div class="sw-gs-guide-video" :class="{
         'is-minimized' : !isSideBarOpen,
         'is-fullscreen' : isFullscreenVideoModalOpen,
         'is-loading' : !callIsSetup,
       }">
        <SwGsStartAppointment v-if="isSideBarOpen"/>

        <template v-if="callIsSetup">
            <div class="sw-gs-video-grid-wrapper">

                <template v-if="hasMembers && ownVideoStream && !isFullscreenVideoModalOpen && !isBroadCastEnabled">
                    <div class="sw-gs-small-video-wrapper">
                        <video :srcObject.prop="ownVideoStream" autoPlay muted playsInline></video>
                    </div>
                </template>

                <template v-if="isSideBarOpen">
                    <div class="sw-gs-big-video-wrapper">
                        <div class="no-cam-box">
                            <SwGsIconCameraOff class="no-cam-icon color-dark-secondary size-l"/>
                            <p v-if="!videoChatEnabled" class="no-cam-text">{{ $t('Video is disabled in this appointment') }}</p>
                        </div>

                        <template v-if="isFullscreenVideoModalOpen || isBroadCastEnabled || (!hasMembers)">
                            <video v-if="ownVideoStream" :srcObject.prop="ownVideoStream" autoPlay muted playsInline></video>
                            <div class="sw-gs-speaker-name">
                                <span>{{ attendeeName }}</span>
                            </div>
                        </template>

                        <template v-if="hasMembers && activeSpeakerStream && !isFullscreenVideoModalOpen">
                            <video :srcObject.prop="activeSpeakerStream" autoPlay muted playsInline></video>
                        </template>

                        <template v-if="!isFullscreenVideoModalOpen && !isBroadCastEnabled && activeSpeaker">
                            <div class="sw-gs-speaker-name">
                                <span v-if="activeSpeaker.data.user_name">{{ activeSpeaker.data.user_name }}</span>
                                <span v-else>{{ $t('Anonymous') }}</span>
                            </div>
                        </template>

                    </div>
                </template>

                <SwGsLayerVideoGuideActions :callData="callData"/>
            </div>
        </template>
        <template v-else-if="isSideBarOpen">
            <SfLoader :loading="true"/>
        </template>


        <SwGsFullScreenVideoModal :callData="callData" v-if="isFullscreenVideoModalOpen"/>
        <SwGsDeviceSettings v-if="isSideBarOpen && isDeviceSettingsOpen"/>
        <SwGsDeviceErrorModal v-if="deviceError"/>

        <!-- Audio-streams -->
        <template v-if="!speakerDeviceMuted">
            <div v-for="participant in memberParticipants" class="sw-gs-video-participant-audio-wrapper">
                <template v-if="participantHasAudioStream(participant)">
                    <audio :key="`${participant.session_id}-audio`" :srcObject.prop="participant.streams.audio" autoplay ref="speakerAudios"></audio>
                </template>
            </div>
        </template>
    </div>
</template>

<script>
import SwButton from "@/components/atoms/SwButton.vue";
import { useVideoCall } from "../../logic/composables/useVideoCall";
import { usePresentationLayer } from "../../logic/composables/usePresentationLayer";
import { computed, ref } from '@vue/composition-api';
import SwGsStartAppointment from '../SwGsStartAppointment.vue';
import SwGsDeviceSettings from '../SwGsDeviceSettings.vue';
import SwGsDeviceErrorModal from '../modals/SwGsDeviceErrorModal.vue';
import SwGsFullScreenVideoModal from '../modals/SwGsFullScreenVideoModal.vue';
import SwGsLayerVideoGuideActions from './SwGsLayerVideoGuideActions.vue';
import { useUIState } from "@shopware-pwa/composables";
import { SfLoader } from "@storefront-ui/vue";
import { useState } from '../../logic/composables/useState';
import { useMediaDevices } from '../../logic/composables/useMediaDevices';
import { SwGsIconCameraOff } from "../icons";

export default {
    name: "SwGsLayerVideoGuide",
    components: {
        SfLoader,
        SwGsIconCameraOff,
        SwButton,
        SwGsStartAppointment,
        SwGsDeviceSettings,
        SwGsFullScreenVideoModal,
        SwGsDeviceErrorModal,
        SwGsLayerVideoGuideActions,
    },
    setup() {
        const {
            setup: setupCall,
            callIsSetup,
            ownParticipant,
            ownVideoStream,
            memberParticipants,
            memberCount,
            hasMembers,
            activeSpeaker,
            activeSpeakerStream,
            toggleMicrophone,
            microphoneState,
            toggleCamera,
            cameraState,
            toggleBroadcastMode,
            isBroadCastEnabled,
            speakerDeviceMuted,
            videoChatEnabled,
            callEnabled,
            speakerAudios,
        } = useVideoCall();

        const { stateForAll, currentGuide } = useState();
        const { hasDevices, hasSavedSettings, deviceError, isAudioOnly, cameraCount, microphoneCount, speakerCount } = useMediaDevices();
        const { sizeState } = usePresentationLayer();

        const { isOpen: isNavigationPageListOpen } = useUIState({ stateName: "GS_NAVIGATION_PAGE_LIST_STATE" });
        const { isOpen: isFullscreenVideoModalOpen, switchState: toggleFullscreenVideoModal } = useUIState({ stateName: "GS_VIDEO_FULLSCREEN_MODAL_STATE" });

        const isDeviceSettingsOpen = ref(false);
        const toggleDeviceSettings = () => isDeviceSettingsOpen.value = !isDeviceSettingsOpen.value;
        const isSideBarOpen = computed(() => sizeState.value === 'maximized');

        setupCall();

        // data to pass to sub components to not execute useVideoCall twice
        const callData = {
            callEnabled,
            videoChatEnabled,
            callIsSetup,
            ownParticipant,
            ownVideoStream,
            memberParticipants,
            hasMembers,
            memberCount,
            activeSpeaker,
            activeSpeakerStream,
            isSideBarOpen,
            toggleMicrophone,
            microphoneState,
            toggleCamera,
            cameraState,
            toggleBroadcastMode,
            isBroadCastEnabled,
            isDeviceSettingsOpen,
            toggleDeviceSettings,
            toggleFullscreenVideoModal: () => toggleFullscreenVideoModal(),
            isFullscreenVideoModalOpen,
            hasDevices,
            hasSavedSettings,
            isAudioOnly,
            cameraCount,
            microphoneCount,
            speakerCount,
            deviceError,
            speakerDeviceMuted,
            speakerAudios
        };

        function participantHasAudioStream(participant) {
            return participant.data?.audio && participant.streams?.audio
        }

        return {
            ...callData,
            attendeeName: computed(() => currentGuide.value?.attendeeName),
            running: computed(() => stateForAll?.value?.running),
            isNavigationPageListOpen,
            participantHasAudioStream,
            callData
        }
    },
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";
@import "../../assets/scss/mixins/mediaQueries";

$bigVideoWidth: 398px;
$bigVideoWidthMobile: 365px;
$bigVideoHeight: $bigVideoWidth * 0.56 + 10px;
$bigVideoHeightMobile: $bigVideoWidthMobile * 0.75 + 10px;

$smallVideoWidth: 125px;
$smallVideoHeight: $smallVideoWidth * 0.56;
$smallVideoHeightMobile: $smallVideoWidth * 0.75;

$videoWrapperHeight: $bigVideoHeight;
$videoWrapperHeightMobile: $bigVideoHeightMobile;
$videoWrapperHeightMinimized: 175px;
$videoWrapperHeightMinimizedMobile: 150px;

.sw-gs-guide-video {
    width: 100%;
    min-height: 200px;
    margin-bottom: 60px;

    &.is-loading {
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .sw-gs-start-meeting-btn {
        position: absolute;
        left: 50%;
        top: 50%;
        transform: translate(-50%, -50%);
    }

    .sw-gs-video-grid-wrapper {
        display: flex;
        width: 100%;
        position: relative;
        height: $videoWrapperHeightMobile;
        transition: height 0.25s ease-in;

        @include for-desktop-small {
            height: $videoWrapperHeight;
        }

        .sw-gs-big-video-wrapper {
            width: $bigVideoWidthMobile;
            height: $bigVideoHeightMobile;
            position: relative;
            left: 5px;
            top: 5px;
            border-radius: 10px;
            overflow: hidden;
            background-color: var(--c-gray-variant);

            @include for-desktop-small {
                width: $bigVideoWidth;
                height: $bigVideoHeight;
            }

            .no-cam-box {
                position: absolute;
                top: calc(50%);
                left: calc(50%);
                transform: translate(-50%, -50%);
                margin: 0 auto;
                .no-cam-icon {
                    margin: 0 auto;
                    width: 50px;
                    height: 50px;
                }
                .no-cam-text {
                    text-align: center;
                }
            }

            video {
                height: 100%;
                width: 100%;
                object-fit: cover;
                position: absolute;
                left: 0;
                right: 0;
                top: 0;
                bottom: 0;
            }

            .sw-gs-active-speaker-placeholder {
                position: absolute;
                top: 50%;
                left: 50%;
                transform: translate(-50%, -50%);
            }

            .sw-gs-speaker-name {
                position: absolute;
                width: 100%;
                bottom: 0;
                left: 0;
                background: rgba(0, 0, 0, 0.5);
                color: var(--c-white);

                span {
                    padding: 0 10px;
                }
            }

            .sw-gs-participants-count {
                position: absolute;
                left: 50%;
                top: 50%;
                transform: translate(-50%, -50%);
            }

            &.is-fullscreen {
                background-color: var(--c-gray-variant);
            }

        }

        .sw-gs-small-video-wrapper {
            position: absolute;
            z-index: var(--helper-lay-over-sibling-z-index);
            bottom: -7px;
            right: 3px;
            border-radius: 5px;
            overflow: hidden;
            display: flex;
            height: $smallVideoHeightMobile;
            width: $smallVideoWidth;
            box-shadow: 0 0 15px 0 rgba(0, 0, 0, 0.6);

            @include for-desktop-small {
                height: $smallVideoHeight;
            }

            video {
                height: 100%;
                width: 100%;
                object-fit: cover;
            }
        }
    }

    ::v-deep .sw-gs-device-settings-wrapper {
        padding: var(--spacer-sm) var(--spacer-xs);
        position: relative;
        top: 73px;
    }

    &.is-minimized {
        height: 100%;

        .sw-gs-video-grid-wrapper {
            height: $videoWrapperHeightMinimizedMobile;

            @include for-desktop-small {
                height: $videoWrapperHeightMinimized;
            }
        }

        ::v-deep .sw-gs-fullscreen-modal .sf-modal__container {
            width: calc(100% - var(--sidebar-minimized-width));
        }
    }

}
</style>
